
/*
  EDMA Advanced Class VOICE_LOGGER
  Copyright (C) 1998-2000 David Martnez Oliveira

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.
*/

/*
**************************************************
    Entorno de Desarrollo Modular y Abierto (EDMA)
    EDMA 0.9.4
    (c) David Martnez Oliveira
    File generated by : EDMA C Implementation Builder class
------------------------------------------------------
    Module Type : CLASS IMPLEMENTATION
    Class List  : VOICE_LOGGER
    Description : Simple voice logger class to access speech server
                  from GNU/EDMA applications
    Author      : David Martnez Oliviera
    Date        : November, 2nd, 2003
    Version     : 0.0
-----------------------------------------------------
  REVISIONS :
***************************************************
*/
 
/*
***************************************************
  General Header Files
***************************************************
*/
 
/* Add here the includes you need for your class*/

/*
***************************************************
  EDMA Header Files
***************************************************
*/
 
#include <edma.h>

/*
***************************************************
  Private Data Struct for class VOICE_LOGGER
***************************************************
*/
 
typedef struct
{
	EPChar		server;
}DtVOICE_LOGGER;
/*
***************************************************
  Method Declaration for class VOICE_LOGGER
***************************************************
*/
 
ESint32 EDMAPROC
VOICE_LOGGERlogZrS32(OBJID IdObj, EPChar str)
{
  DtVOICE_LOGGER	*m;
  OBJID                 id;
  EDMAT_BUFFER          tx_buf;
  ESint32               n;

  m = (DtVOICE_LOGGER *) edma_get_data_ref (IdObj);

  if ((id = edma_new_obj ("CHANNEL")) == -1)
    {
      edma_printf ("%s", "Can't create 'CHANNEL' object");
      return -1;
    }

  n = strlen (str);
  edma_buffer_alloc (&tx_buf, n + 1);
  strcpy (tx_buf.dat, str);

  edma_printf_obj (IdObj, "'%s'(%d bytes)<- '%s'", m->server, n, tx_buf.dat);

  edma_met3 (id, "open", m->server);
  edma_met3 (id, "send", tx_buf, n);
  edma_met3 (id, "close");

  edma_buffer_free (&tx_buf);

  edma_free_obj (id);

  return 0;

}


ESint32 EDMAPROC
VOICE_LOGGERborn(OBJID IdObj)
{
  DtVOICE_LOGGER	*m;

  m = (DtVOICE_LOGGER *) edma_get_data_ref (IdObj);

  return 0;
}


ESint32 EDMAPROC
VOICE_LOGGERrip(OBJID IdObj)
{
  DtVOICE_LOGGER	*m;

  m = (DtVOICE_LOGGER *) edma_get_data_ref (IdObj);

  return 0;
}



/********** END C IMPLEMENTATION SKELETON ******************/
