#include <stdio.h>
#include <string.h>

#include <edma.h>

int
main(int argc, char *argv[])
{
  OBJID           id;
  EDMAT_BUFFER    tx_buf;
  ESint32         n;

  if (argc != 3)
    {
      edma_printf ("%s", "Wrong number of parameters");
      edma_printf ("%s", "Usage:");
      edma_printf ("%s", "  edma_log CHANNEL MSG");
      edma_printf ("%s", "  edma_log >SOCKET_UDP://192.168.1.72:10103");

      return -1;
    }

  EDMAInit();

  if ((id = edma_new_obj ("CHANNEL")) == -1)
    //if ((id = edma_new_obj ("SOCKET_UDP")) == -1)
    {
      edma_printf ("%s", "Can't create 'CHANNEL' object");
      EDMAEnd();
      return -1;
    }
  n = strlen (argv[2]);
  edma_buffer_alloc (&tx_buf, n + 1);
  strcpy (tx_buf.dat, argv[2]);
  edma_printf ("About to log '%s' to '%s' %d bytes", tx_buf.dat, argv[1], n);

  edma_met3 (id, "open", argv[1]);
  //edma_met3 (id, "Open", "192.168.1.72:10103", 1); 
  edma_met3 (id, "send", tx_buf, n);
  edma_met3 (id, "close");

  edma_buffer_free (&tx_buf);

  edma_free_obj (id);
  EDMAEnd();
}
