#include <stdio.h>
#include <string.h>

#include <edma.h>

int
main(int argc, char *argv[])
{
  OBJID           id;

  if (argc != 3)
    {
      edma_printf ("%s", "Wrong number of parameters");
      edma_printf ("%s", "Usage:");
      edma_printf ("%s", "  edma_log CHANNEL MSG");
      edma_printf ("%s", "  edma_log >SOCKET_UDP://192.168.1.72:10103");

      return -1;
    }

  EDMAInit();

  if ((id = edma_new_obj ("VOICE_LOGGER")) == -1)
    {
      edma_printf ("%s", "Can't create 'VOICE_LOGGER' object");
      EDMAEnd();
      return -1;
    }

  edma_printf ("About to log '%s' to '%s'", argv[2], argv[1]);

  edma_wprop3 (id, "server", argv[1]);
  edma_met3 (id, "log", argv[2]);
  edma_free_obj (id);

  EDMAEnd();
}
