#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <time.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <errno.h>
#include <pthread.h>

#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <syslog.h>

#define PORT        10103
#define MAX_MSG_LEN 2048
#define VERSION     "0.0"
#define MAX_MSGS    5

#define DAEMON  1

char *last_msg[MAX_MSGS];
int  first, last, current;

/* GLobal vars*/
/*
char    *buffer[];
int     waiting_msg=0;

pthread_t   speech;
pthread_mutex_t  mut = PTHREAD_MUTEX_INITIALIZER;

// pthread_mutex_lock (&mut);
//...
// pthread_mutex_unlock (&mut);
*/
/***************************************************************/
/* closeall() - close all FDs >= a specified value */

void closeall(int fd)
{
    int fdlimit = sysconf(_SC_OPEN_MAX);

    while (fd < fdlimit)
      close(fd++);
}

int daemon(int nochdir, int noclose)
{
    switch (fork())
    {
        case 0:  break;
        case -1: return -1;
        default: _exit(0);          /* exit the original process */
    }

    if (setsid() < 0)               /* shoudn't fail */
      return -1;

    /* dyke out this switch if you want to acquire a control tty in the */
    /* future - not normally advisable for daemons */

    switch (fork())
    {
        case 0:  break;
        case -1: return -1;
        default: _exit(0);
    }

    if (!nochdir)
      chdir("/");

    if (!noclose)
    {
        closeall(0);
        open("/dev/null",O_RDWR);
        dup(0); dup(0);
    }

    return 0;
}

/****************************************************************/

void *say(void*);
/* Just a speech server using festival */

int                 finish = 0;

void
the_end (int signal)
{
  voice ("Oops. Somebody kill me. Bye, bye.");
  finish = 1;
  
}

void my_syslog (int type, char *msg)
{
#if DAEMON
  syslog (type, msg);
#else
  printf ("%s", msg);
#endif
}

main ()
{
  int                 s;   /* Server socket */
  char                *rcv_buf[MAX_MSG_LEN];
  char                msg[1024];
  struct sockaddr_in  remote,local;
  struct tm           *hh;
  fd_set              frd;
  struct timeval      tv;
  int                 aux1, len, flag = 1;
  int                 cnt, i;
  
  /* Daemonize process*/
#if DAEMON
  if (daemon(0,0) < 0)
    {
      perror("daemon");
      exit(2);
    }
#endif
  
  /* Caught signals*/
  signal (SIGUSR1, the_end);
  signal (SIGTERM, the_end);
  signal (SIGKILL, the_end);
  signal (SIGSEGV, the_end);
  signal (SIGQUIT, the_end);

#if DAEMON
  openlog("speech_server", LOG_PID, LOG_DAEMON);
#endif

  my_syslog (LOG_INFO, "going up");
  voice ("Speech server is been setting up.");
  
  /* First of all launch the speech thread*/
  /*
  if ((pthread_create (&speech, NULL, say, NULL)) != 0)
  {
  fprintf (stderr, "Can't init threads.... Aborting\n");
      voice ("Can't init threads. Aborting");
      exit (1);
    }


  */
  for (i = 0; i < MAX_MSGS; i++)
    last_msg[i] = NULL;
  
  current = first = last = 0;
  
  /* Create UDP socket */
  
  if ((s = socket (AF_INET, SOCK_DGRAM, 0)) < 0)
    {
      my_syslog (LOG_INFO, "Can't create socket. Aborting\n");
      voice ("Can't create UDP socket. Aborting\n");
      exit (1);
    }
  
  fcntl (s, F_SETFL, O_NONBLOCK);
  if ((setsockopt(s, SOL_SOCKET, SO_REUSEADDR, &flag, sizeof(flag))) < 0)
    {
      my_syslog (LOG_INFO, "Can't set socket options");
      voice ("Can't set socket options. Aborting.");
      exit (1);
    }
  /* Name the socket*/
  local.sin_addr.s_addr=INADDR_ANY;
  local.sin_family=AF_INET;
  local.sin_port=htons(PORT);

  if ((bind (s, (struct sockaddr *) &local, sizeof (local))) < 0) 
    {
      my_syslog (LOG_INFO,"Can't bind UDP socket. Aborting");
      voice ("Can't bind UDP socket. Aborting");
      close(s);
      exit (1);
    }
  
  voice ("Waiting for new messages.");
  cnt = 0;
  while (!finish)
    {
      memset (rcv_buf, 0, MAX_MSG_LEN);
      
      FD_ZERO(&frd);
      FD_SET(s,&frd);
      
      tv.tv_sec = 0;
      tv.tv_usec = 10000;  /* 10ms timeout */
      
      //my_syslog (LOG_INFO, "Waiting on select\n");
      len = select (s + 1, &frd, NULL, NULL, &tv);
      if (len < 0) 
	{
	  my_syslog (LOG_INFO, "Select error");
	  continue;
	}
      if (len == 0)
	{
	  cnt ++;
	  if (cnt == 10000) /* 2 minutes without activity*/
	    {
	      /* FIXME: Remove stored messages after some time*/
#ifdef DEBUG
	      my_syslog (LOG_INFO, "Removing old messages");
#endif
	      for (i = 0; i < MAX_MSGS; i++)
		if (last_msg[i] != NULL)
		  {
#ifdef DEBUG
		    snprintf (msg, MAX_MSG_LEN, "Freeing message %d at %p\n", i, last_msg[i]);
		    my_syslog (LOG_INFO, msg);
#endif
		    free (last_msg[i]);
		    last_msg[i] = NULL;
		  }
	      current = 0;
#ifdef DEBUG
	      my_syslog (LOG_INFO, "Succesfully removed");
#endif
	      //voice ("I'm idle");
	      cnt = 0;
	    }
	  continue;
	}

      cnt = 0;
      if ((len = recvfrom (s, rcv_buf, MAX_MSG_LEN,
			   0,(struct sockaddr*)&remote,&aux1))<0) {
	continue;
      }
      /* Check if message is the same that some of the recently received*/
      for (i = 0; i < MAX_MSGS; i++)
	if (last_msg[i] != NULL)
	  if ((strncmp ((char*)rcv_buf, last_msg[i], MAX_MSG_LEN)) == 0)
	    {
#ifdef DEBUG
	      snprintf (msg, MAX_MSG_LEN, "Found current message in %d\n", i);
	      my_syslog (LOG_INFO, msg);
#endif
	      break;
	    }
      
      if (i == MAX_MSGS)
	{
#ifdef DEBUG
	  snprintf (msg, MAX_MSG_LEN, "Message not found. "
		    "Storing it in current pointer %d at %p (size: %d)\n", 
		    current, last_msg[i], strlen (rcv_buf));
	  my_syslog (LOG_INFO, msg);
#endif
	  if (last_msg[current] != NULL)
	    free (last_msg[current]);
	  
	  //if ((last_msg[current] = (char *) malloc (strlen (rcv_buf))) == NULL)
	  if ((last_msg[current] = strdup ((char*)rcv_buf)) == NULL)
	    {
	      my_syslog (LOG_INFO, "Can't allocate memory for incomming message");
	      continue;
	    }
	  //strcpy (last_msg[current], rcv_buf);
	  
	  current++;
	  if ( current >= MAX_MSGS)
	    {
#ifdef DEBUG
	      my_syslog (LOG_INFO, "Last message list full, reseting...");
#endif
	      current = 0;
	    }

	  voice (rcv_buf);
	}
    }

  close (s);
  my_syslog (LOG_INFO, "shutting down");
  voice ("Speech server is down");
  return 0;
}

int voice (char *s)
{
  char     cmd[5000];
  
  sprintf (cmd, "echo \"%s\" | festival --tts", s);
  system (cmd);
  return 0;
}

void *say(void *param)
{
  
}
